Just grabbing the Python comments for now, formatting later:


    """A generic class for all models to inherit from
    
    
    Attributes we've got so far:
    
    backend -- string; could be 'keras' (default and also what we get if left to None), 'pymvpa', maybe other stuff in future
    
    model_func, model_args -- one way to instantiate the model (by providing your own function and arguments). If these are specified,
        then when it's time to build the model, we basically just call model_func and pass it model_args
    
    model -- will hold the eventual model. Not really intended for the user to set, although presumably they could if they knew what 
        they were doing.
    
    layers -- if this is specified, presumably we're doing a neural network model (which at the moment implies Keras; may not always). 
        Should be mutually exclusive with instantiating via 'model_func' and 'model_args'.
    
    build_now -- build upon initialization? (Defaults to False, although True might make more sense in the future if it doesn't break 
        any existing assumptions.)
    
    
    
    Proposed future attributes:
    
    needs_rebuilding -- when the code is sufficiently mature, there may be occasion to mark an old model as "dirty" (e.g. when some aspect 
        of the model has been changed but build() has not been called yet to rebuild it). Then presumably when DTAnalysis is ready to run, 
        this will let it query the model to see if it's "dirty" and issue a warning or error letting the user know of the mismatch. 
        (Alternately, we could just clear the model as soon as some attribute is changed that would invalidate the previously built model, 
        but that seems less flexible long-term.)
    
    
    Methods we've got so far:
    
    validate_arguments() -- all major classes will need one of these to help DTBatch decide if batch file structures are valid. Takes in a dict of 
        keys/values, which are presumed to represent input arguments to this class's initializer. Returns True if valid and False if not.
    
    """
